DATA DATA0;     
INFILE 'G:\BOX-ANN\CHILD.dat';   
INPUT k y1 x11 x12 @@;  
 
t=_N_; 
y=(y1-90)/(120-90); x1=(x11-1)/(6-1); x2=(x12-20)/(30-20);
                        /* x1=0.8; x2=0.9; x11=5; x12=29 */
eta=0.01;               /* 0.5 */
                      
h=1;                    /* change the seed of random numbers */                     
/* UNIFORM RANDOM NUMBERS for weights and biases */
IF UNIFORM(1+h)<=0.5 THEN w1_11=-UNIFORM(1+h)/10; ELSE w1_11=UNIFORM(1+h)/10;
IF UNIFORM(2+h)<=0.5 THEN w1_21=-UNIFORM(2+h)/10; ELSE w1_21=UNIFORM(2+h)/10;
IF UNIFORM(3+h)<=0.5 THEN w1_12=-UNIFORM(3+h)/10; ELSE w1_12=UNIFORM(3+h)/10;
IF UNIFORM(4+h)<=0.5 THEN w1_22=-UNIFORM(4+h)/10; ELSE w1_22=UNIFORM(4+h)/10;
IF UNIFORM(5+h)<=0.5 THEN w1_13=-UNIFORM(5+h)/10; ELSE w1_13=UNIFORM(5+h)/10;
IF UNIFORM(6+h)<=0.5 THEN w1_23=-UNIFORM(6+h)/10; ELSE w1_23=UNIFORM(6+h)/10;
IF UNIFORM(7+h)<=0.5 THEN w1_14=-UNIFORM(7+h)/10; ELSE w1_14=UNIFORM(7+h)/10;
IF UNIFORM(8+h)<=0.5 THEN w1_24=-UNIFORM(8+h)/10; ELSE w1_24=UNIFORM(8+h)/10;
IF UNIFORM(9+h)<=0.5 THEN b1=-UNIFORM(9+h)/10; ELSE b1=UNIFORM(9+h)/10;
IF UNIFORM(10+h)<=0.5 THEN b2=-UNIFORM(10+h)/10; ELSE b2=UNIFORM(10+h)/10;
IF UNIFORM(11+h)<=0.5 THEN b3=-UNIFORM(11+h)/10; ELSE b3=UNIFORM(11+h)/10;
IF UNIFORM(12+h)<=0.5 THEN b4=-UNIFORM(12+h)/10; ELSE b4=UNIFORM(12+h)/10;
IF UNIFORM(13+h)<=0.5 THEN b5=-UNIFORM(13+h)/10; ELSE b5=UNIFORM(13+h)/10; 
IF UNIFORM(14+h)<=0.5 THEN w2_11=-UNIFORM(14+h)/10; ELSE w2_11=UNIFORM(14+h)/10;
IF UNIFORM(15+h)<=0.5 THEN w2_21=-UNIFORM(15+h)/10; ELSE w2_21=UNIFORM(15+h)/10;
IF UNIFORM(16+h)<=0.5 THEN w2_31=-UNIFORM(16+h)/10; ELSE w2_31=UNIFORM(16+h)/10;
IF UNIFORM(17+h)<=0.5 THEN w2_41=-UNIFORM(17+h)/10; ELSE w2_41=UNIFORM(17+h)/10;
IF UNIFORM(18+h)<=0.5 THEN b6=-UNIFORM(18+h)/10; ELSE b6=UNIFORM(17+h)/10; 

/* FIRST LINEAR TRANSFORMATION */
z1=w1_11*x1+w1_21*x2; z2=w1_12*x1+w1_22*x2;   
z3=w1_13*x1+w1_23*x2; z4=w1_14*x1+w1_24*x2;   

/* FIRST ACTIVITY FUNCTION */
s1=1/(1+exp(-(z1+b1))); s2=1/(1+exp(-(z2+b2)));
s3=1/(1+exp(-(z3+b3))); s4=1/(1+exp(-(z4+b4)));                                          

/* SECOND LINEAR TRANSFORMATION */ 
z5=w2_11*s1+w2_21*s2+w2_31*s3+w2_41*s4;

/* FIRST ESTIMATED VALUE */ 
s5=1/(1+exp(-(z5+b5)));
y_hat=s5; 

/* ORIGINAL UNIT FOR y_hat=s5; */
By_hat=y_hat*(120-90)+90;

SYMBOL1 v=dot cv=black l=1 color=red;
SYMBOL2 v=circle cv=black i=spline ci=black; 
SYMBOL3 v=star cv=black i=line ci=black; 
SYMBOL4 v=none cv=black i=join ci=black; 
SYMBOL5 v=none cv=black i=line ci=black; 
SYMBOL6 v=none cv=black i=spline ci=black;

/* PROC PRINT; VAR x1 x2;
RUN; */

PROC PRINT DATA=DATA0; VAR w1_11 w1_21 w1_12 w1_22 w1_13 w1_23 w1_14 w1_24;
RUN;

PROC PRINT DATA=DATA0; VAR w2_11 w2_21 w2_31 w2_41;
RUN;

PROC PRINT DATA=DATA0; VAR z1 z2 z3 z4 z5 s1 s2 s3 s4 s5 y_hat By_hat;
RUN; 

/* proc print; var x10 x20 x11 x12; 
run; 

PROC PRINT DATA=DATA0; VAR z10 z20 z30 z40 s10 s20 s30 s40 s50 y0_hat By0_hat;
RUN; */

PROC PRINT DATA=DATA0; VAR w1_11 w1_21 w1_12 w1_22 w1_13 w1_23 w1_14 w1_24;
RUN;

PROC REG DATA=DATA0;                /* orignal data by_hat */
MODEL y1=x11 x12/p clb vif alpha=0.05;
OUTPUT OUT=new PREDICTED=pred RESIDUAL=resid;
RUN;

PROC REG DATA=DATA0;                /* orignal data by_hat */
MODEL y=x1 x2/p clb vif alpha=0.05;
OUTPUT OUT=new1 PREDICTED=pred1 RESIDUAL=resid1;
RUN;








