/* winters method */
DATA passenger; 
INFILE 'C:\passenger.dat'; 
input passenger @@; 
DATE=intnx('month', '01jan49'd,_n_-1);
format date monyy.;
run;

SYMBOL1 v=none  h=0.5 i=join   l=3 c=black;
SYMBOL2 v=plus  h=0.5 i=spline l=1 c=black;
SYMBOL3 v=point h=0.5 i=join   l=1 c=black;
SYMBOL4 v=point h=0.5 i=join   l=1 c=black; 

PROC GPLOT data=passenger; 
plot passenger*date=1 /grid frame 
vaxis=-100 to 800 by 100 
haxis='01jan49'd to '01jan62'd by year HREF='01jan61'd;
run;

/* Fit multiplicative seasonal model 184 */
PROC FORECAST data=passenger method=winters interval=month 
trend=2 lead=12 out=pred outfull outresid outest=est;
var passenger; 
id date;    
run;    

PROC PRINT data=est;
run;
PROC PRINT data=pred;
run;

PROC GPLOT data=pred;
plot passenger*date=_type_ / VREF=0 
vaxis=-100 to 800 by 100 
haxis='01jan49'd to '01jan62'd by year HREF='01jan61'd;
run;

DATA passenger;
infile 'C:\passenger.dat'; 
input passenger @@; 
DATE=intnx('month', '01jan49'd,_n_-1);
format date monyy.;

SYMBOL1 v=none  h=0.5 i=join   l=3 c=black;
SYMBOL2 v=plus  h=0.5 i=spline l=1 c=black;
SYMBOL3 v=point h=0.5 i=join   l=1 c=black;
SYMBOL4 v=point h=0.5 i=join   l=1 c=black; 

PROC GPLOT DATA=passenger;
PLOT passenger*date=1/grid frame
haxis='01jan49'd to '01jan62'd by year HREF='01jan61'd;
RUN;

PROC FORECAST data=passenger method=winters interval=month trend=2  
seasons=12 start=142 lead=12 out=pred2 out=out outfull outresid outest=est;
id date; var passenger; 
run;    
/* 185 ADD RIGHT out=pred2 */

/* 3 BELOW: add not nece */
/* PROC PRINT data=OUT; run; NO */
PROC PRINT data=est; run;
PROC PRINT data=pred2; run;

PROC GPLOT data=PRED2; /* MY ADD */ 
plot passenger*date=_type_ /grid frame
haxis='01jan49'd to '01jan62'd by year HREF='01jan61'd VREF=0;
where _type_^='RESIDUAL';
run;

PROC GPLOT data=pred2; 
plot passenger*date=_type_ / VREF=0 
vaxis=-100 to 800 by 100 
haxis='01jan49'd to '01jan62'd by year HREF='01jan61'd;
run; /* ADD */

PROC FORECAST data=passenger method=addwinters interval=month trend=2
seasons=12 start=142 lead=12 /* ADD RIGHT */ out=pred3 out=out1 outfull outresid outest=est1;
id date; var passenger; 
run;    
/* 186 */
/* TWO BELOW: add not nece */
/* PROC PRINT data=OUT1; run; NO */
PROC PRINT data=est1; run;
PROC PRINT data=pred3; run;

PROC GPLOT data=PRED3;
plot passenger*date=_type_ /grid frame
haxis='01jan49'd to '01jan62'd by year HREF='01jan61'd VREF=0;
where _type_^='RESIDUAL';
run;

PROC GPLOT data=pred3; 
plot passenger*date=_type_ / VREF=0 
vaxis=-100 to 800 by 100 
haxis='01jan49'd to '01jan62'd by year HREF='01jan61'd;
run; /* ADD */
