DATA INCOMES;
INFILE 'G:\BOX-ANN\INCOMES.dat'; 
INPUT X @@;
LOGX=log(X);      /* natual logarithm */
L1X=dif(LOGX);   /* nonseasonal first difference lag1(LOGX)*/
date=intnx('qtr', '1jan60'd,_n_-1);
format date yyq.;

PROC PRINT; 
RUN;

SYMBOL1 v=dot cv=black i=spline ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black;
SYMBOL3 v=none cv=black i=line ci=black;

PROC GPLOT DATA=INCOMES;
PLOT X*DATE=3 /VREF=0 grid frame vaxis=1000 to 5000 by 500;
RUN;

PROC ARIMA DATA=INCOMES;
IDENTIFY VAR=X NLAG=60;  
ESTIMATE P=1 method=ML;
FORECAST LEAD=5 OUT=out1;
RUN;

PROC GPLOT DATA=INCOMES;
PLOT LOGX*DATE=3 /VREF=0 grid frame ;
RUN;

PROC ARIMA DATA=INCOMES;
IDENTIFY VAR=logX NLAG=60;  
ESTIMATE P=1 method=ML;
FORECAST LEAD=5 OUT=out2;
RUN;


PROC ARIMA DATA=INCOMES;
IDENTIFY VAR=L1X NLAG=60;  
ESTIMATE P=1 method=ML;
FORECAST LEAD=5 OUT=out3;
RUN;

PROC GPLOT DATA=INCOMES;
PLOT L1X*DATE=3 /VREF=0 grid frame vaxis=-0.5 to 0.5 by 0.05;
RUN;


