DATA INCOMES;
INFILE 'G:\FSAScodedata_2010\INCOMES.dat'; 
INPUT X @@;
t=_N_;
LOGX=log(X);      /* natual logarithm */
L1X=dif1(LOGX);   /* first diff for deleting linear trend */
L14X=dif4(L1X);   /* log, 1st diff, 4th diff */ 
L142X=dif2(L14X); /* log, 1st diff, 4th diff  2nd diff */ 
wt=L14X;

date=intnx('qtr', '1jan60'd,_n_-1);
format date yyq.;

/* IF t>98 THEN DELETE; */

PROC PRINT; var t X LOGX L1X L14X L142X wt; 
RUN; 

SYMBOL1 v=dot cv=black i=line ci=black;
SYMBOL2 v=circle cv=black i=line ci=black;
SYMBOL3 v=none cv=black i=line ci=black;
SYMBOL4 v=none cv=black i=spline ci=black;
SYMBOL5 v=star cv=black i=line ci=black;

PROC GPLOT DATA=INCOMES;
PLOT X*t=1/overlay grid frame ;
RUN;

PROC GPLOT DATA=INCOMES;
PLOT X*DATE=3 /VREF=0 grid frame vaxis=1000 to 5000 by 500;
RUN;

PROC GPLOT DATA=INCOMES;
PLOT L1X*DATE=3 /VREF=0 grid frame vaxis=-0.5 to 0.5 by 0.1; 
RUN;

PROC GPLOT DATA=INCOMES;
PLOT L14X*DATE=3 /VREF=0 grid frame vaxis=-0.3 to 0.3 by 0.05;
RUN;

PROC GPLOT DATA=INCOMES;
PLOT L142X*DATE=3 /VREF=0 grid frame vaxis=-0.3 to 0.3 by 0.05;
RUN;

PROC GPLOT DATA=INCOMES;
PLOT wt*DATE=1 /VREF=0 grid frame vaxis=-0.25 to 0.25 by 0.05;
RUN;

PROC ARIMA DATA=INCOMES;
IDENTIFY VAR=L14X NLAG=30;    /* VAR=LOGX(1,4) */
ESTIMATE Q=4 method=CLS plot; /* Q=3 is same as Q=(1,2,3) */
FORECAST LEAD=10 OUT=out10;
RUN;

PROC ARIMA DATA=INCOMES;
IDENTIFY VAR=LOGX(1,4) NLAG=30;        /* same as SAME VAR=L14X */
ESTIMATE Q=(1,2,3,4) method=CLS plot;  /* Q=(1,2,3,4)is same as Q=4 */
FORECAST LEAD=10 OUT=out11;
RUN;

proc print data=out11;
run;

DATA NEW;
MERGE INCOMES out11;
x_ori=exp(LOGX); fo_ori=exp(FORECAST);
L95_ori=exp(L95); U95_ori=exp(U95); res_ori=exp(RESIDUAL);
RUN;

PROC PRINT; VAR x_ori fo_ori L95_ori U95_ori;
RUN;

proc gplot DATA=NEW;
plot x_ori*t=1 fo_ori*t=2 L95_ori*t=5 U95_ori*t=5 /OVERLAY HREF=97.5 grid frame;             
run;

DATA NEW;
IF t>101 THEN DELETE; 
MERGE INCOMES out11;
x_ori=exp(LOGX); fo_ori=exp(FORECAST); L95_ori=exp(L95); U95_ori=exp(U95);
res_ori=exp(RESIDUAL);
RUN;

PROC PRINT DATA=NEW; VAR x_ori fo_ori L95_ori U95_ori;
RUN;

proc gplot;
plot x_ori*t=1 fo_ori*t=2 L95_ori*t=5 U95_ori*t=5/OVERLAY grid frame
haxis=0 to 121 by 10; 
run;



/*
proc gplot DATA=NEW2;
plot RESIDUAL*t=3/vref=0 vaxis=-0.5 to 0.5 by 0.2;             
run;

PROC UNIVARIATE DATA=OUT11 NORMAL PLOT; 
VAR RESIDUAL;
RUN;

DATA INCOMESEST;
INPUT t x_ori L95_ori U95_ori @@;
CARDS;
98   .       .       .
99  0.0034 -0.0255 0.0323
100 -0.0005 -0.0274 0.0284 
101 -0.0008 -0.0297 0.0281
102 -0.0041 -0.0334 0.0253
103 -0.0004 -0.0341 0.0333
104 -0.0004 -0.0341 0.0333
105 -0.0004 -0.0341 0.0333
106 -0.0004 -0.0341 0.0333
107 -0.0004 -0.0341 0.0333
108 -0.0004 -0.0341 0.0333
;

DATA COMB;
SET INCOMES INCOMESEST; 
RUN;

PROC PRINT; VAR t L14X;
RUN;
*/

/*
PROC GPLOT DATA=COMB;
PLOT L14X*t=1 L*t=4 U*t=4/overlay grid frame 
VREF=0 HREF=112.5 vaxis=-0.2 to 0.2 by 0.02;
RUN;
*/

/*
PROC GPLOT DATA=INCOMES;
PLOT Xt*t=1 /overlay grid frame ;
RUN;

PROC GPLOT DATA=INCOMES;
PLOT rt*t=1 /overlay grid frame ;
RUN;

PROC GPLOT DATA=INCOMES;
PLOT tot*t=1 /overlay grid frame ;
RUN; 


RANDOM=0+1*RANNOR(54321);
MU=0; TH1=0; TH2=0; TH3=-0.17129; TH4=0.57129;
MU=0; TH1=0; TH2=0; TH3=0; TH4=0;

Xt=((Lag1(X)*Lag4(X))/Lag5(X));
rt=exp(MU+RANDOM-TH1*Lag1(RANDOM)-TH2*Lag2(RANDOM)-TH3*Lag3(RANDOM)-TH4*Lag4(RANDOM)); 
tot=Xt*rt; 


PROC ARIMA DATA=INCOMES;
IDENTIFY VAR=L14X NLAG=30;  
ESTIMATE q=4 method=ML plot;
FORECAST LEAD=10 OUT=out5;
RUN; */

/* 
PROC ARIMA DATA=INCOMES;
IDENTIFY VAR=X NLAG=30;  
RUN;

PROC ARIMA DATA=INCOMES;
IDENTIFY VAR=LOGX NLAG=30;  
ESTIMATE P=1 method=ML;
FORECAST LEAD=10 OUT=out3; 
RUN;


PROC ARIMA DATA=INCOMES;
IDENTIFY VAR=L14X NLAG=30;  
ESTIMATE q=3 method=ML plot;  
FORECAST LEAD=10 OUT=out5;
RUN;


PROC ARIMA DATA=INCOMES;
IDENTIFY VAR=L4X NLAG=30;  
ESTIMATE q=3 method=ML;
FORECAST LEAD=5 OUT=out4;
RUN;

PROC ARIMA DATA=INCOMES;
IDENTIFY VAR=L12X NLAG=30;  
ESTIMATE q=3 method=ML plot;
FORECAST LEAD=5 OUT=out5;
RUN;



PROC GPLOT DATA=INCOMES;
PLOT L12X*DATE=3 /VREF=0 grid frame vaxis=-0.5 to 0.5 by 0.1; 
RUN;

PROC GPLOT DATA=INCOMES;
PLOT L4X*DATE=3 /VREF=0 grid frame vaxis=-0.5 to 0.5 by 0.1; 
RUN;

PROC GPLOT DATA=INCOMES;
PLOT L14X*DATE=3 /VREF=0 grid frame vaxis=-0.3 to 0.3 by 0.05;
RUN;

MU=-0.0003604; TH1=0.14796; TH2=0.16667; TH3=-0.05496; TH4=0.74009; 
   MU=0.0003604; TH1=-0.14796; TH2=-0.16667; TH3=0.05496; TH4=-0.74009; 

PROC ARIMA DATA=INCOMES;
IDENTIFY VAR=L14X NLAG=30;  
ESTIMATE q=4; 
FORECAST LEAD=5 OUT=out5;
RUN;

PROC ARIMA DATA=INCOMES;
IDENTIFY VAR=L14X NLAG=30;  
ESTIMATE q=4 method=ULS plot; 
FORECAST LEAD=5 OUT=out5;
RUN;

PROC ARIMA DATA=INCOMES;
IDENTIFY VAR=L142X NLAG=30;  
ESTIMATE q=3 method=ML plot;
FORECAST LEAD=5 OUT=out6;
RUN;  

PROC ARIMA DATA=INCOMES;
IDENTIFY VAR=L142X NLAG=30;  
ESTIMATE q=4 method=ML plot;
FORECAST LEAD=5 OUT=out6;
RUN;  
*/