DATA sunspot;
INFILE 'G:\BOX-ANN\SUNSPOT.dat';
t=_N_;
INPUT SUN @@;

PROC PRINT; VAR t SUN;
RUN; 

PROC ARIMA DATA=sunspot; 
IDENTIFY VAR=SUN NLAGS=24 OUTCOV=safpacf;
ESTIMATE P=15 METHOD=ML PLOT;
FORECAST LEAD=12 OUT=out1;
RUN;

SYMBOL1 v=dot cv=black i=line ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black; 
SYMBOL3 v=none cv=black i=join ci=black; 
SYMBOL4 v=none cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=spline ci=black; 
SYMBOL6 v=star cv=black i=line ci=black; 

DATA final;
SET out1;
t=_N_;
IF t>459 THEN SUN=L95; 
IF t<=459 THEN L95=.; 
IF t>459 THEN SUN=U95;
IF t<=459 THEN U95=.;
/* IF t<459 THEN forecast=.;*/
RUN;

proc print data=safpacf; 
run;


DATA nsafpacf;
SET safpacf;
LABLE CORR=ACF PARTCORR=PACF;
NSTDERR=(-1)*STDERR;
RUN;

PROC GPLOT DATA=nsafpacf; 
PLOT CORR*LAG=6 STDERR*LAG=2 NSTDERR*LAG=2/OVERLAY legend
GRID FRAME VREF=0 VAXIS=-1 TO 1 BY 0.2 HAXIS=0 TO 24 BY 1;
RUN;

PROC GPLOT DATA=nsafpacf; 
PLOT PARTCORR*LAG=6 /* STDERR*LAG=2 NSTDERR*LAG=2 */ /OVERLAY legend
GRID FRAME VREF=0 VREF=0.09335 VREF=-0.09335 VAXIS=-1 TO 1 BY 0.2 HAXIS=1 TO 24 BY 1;
RUN;

PROC FORECAST DATA=final;
VAR SUN;
RUN;

PROC GPLOT DATA=final; 
PLOT SUN*t=4 forecast*t=4 L95*t=6 U95*t=6/OVERLAY legend
GRID FRAME HREF=450 VAXIS=-20  TO 200 BY 20 HAXIS=0 TO 500 BY 50;;
RUN;
quit;

