DATA invento;
INFILE 'G:\SAScodedata\INVENTO.dat';   
t=_N_;
TIME=t;
INPUT xt @@;
xt1=DIF1(xt);

PROC PRINT DATA=INVENTO; 
RUN; 

SYMBOL1 v=dot cv=black i=line ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black;
SYMBOL3 v=none cv=black i=spline ci=black;

PROC MEANS DATA=INVENTO; 
RUN;

PROC GPLOT;
PLOT xt*t=1/VREF=6.095 OVERLAY grid frame 
vaxis=-20 to 30 by 5 haxis=0 to 60 by 5;
RUN;

PROC GPLOT DATA=INVENTO;
PLOT xt1*t=1/VREF=0.030 OVERLAY grid frame 
vaxis=-20 to 30 by 5 haxis=0 to 60 by 5;
RUN;

PROC ARIMA;
IDENTIFY VAR=xt NLAG=20;
ESTIMATE P=1;
FORECAST ID=TIME LEAD=20 OUT=GEOUT;
RUN;

PROC GPLOT DATA=GEOUT;
PLOT FORECAST*TIME=1 (l95 u95)*TIME=3 xt*TIME=3/OVERLAY grid frame VAXIS=-30 TO 35 by 5 
haxis=1 to 90 by 5 VREF=6.095 HREF=60;
PLOT RESIDUAL*TIME=1/OVERLAY grid frame VAXIS=-30 TO 35 by 5 
haxis=1 to 60 by 1 VREF=0 HREF=60;
RUN;

PROC PRINT DATA=GEOUT; VAR RESIDUAL;
RUN;

PROC MEANS DATA=GEOUT; VAR RESIDUAL; 
RUN;

QUIT;


