DATA hotel;
INFILE 'G:\BOX-JENKINS\HOTEL3.dat';
INPUT t x m;
lnx=log(x);

SYMBOL1 v=dot cv=black i=line ci=black;
SYMBOL2 v=circle cv=black i=line ci=black;
SYMBOL3 v=none cv=black i=line ci=black;
 
PROC ARIMA;
IDENTIFY VAR=X NLAG=36;
RUN;

PROC ARIMA;
IDENTIFY VAR=lnx NLAG=36;
RUN;

PROC ARIMA;
IDENTIFY VAR=lnx(1) NLAG=36;
RUN;

PROC ARIMA;
IDENTIFY VAR=lnx(12) NLAG=36;
RUN;

PROC ARIMA;                                  /* Model (1) */
IDENTIFY VAR=lnx(12) NLAG=36;
ESTIMATE Q=(12) method=ML;
FORECAST LEAD=5 OUT=out1;
RUN;

PROC ARIMA;                                  /* Model (2) */
IDENTIFY VAR=lnx(12) NLAG=36;
ESTIMATE P=(1) Q=(12) method=ML;
FORECAST LEAD=5 OUT=out2;
RUN;

PROC ARIMA;                                  /* Model (3) */
IDENTIFY VAR=lnx(12) NLAG=36;
ESTIMATE P=(1,2) Q=(12) method=ML;
FORECAST LEAD=5 OUT=out3;
RUN;

PROC ARIMA;                                  /* Model (4) */
IDENTIFY VAR=lnx(12) NLAG=36;
ESTIMATE P=(1,2,3) Q=(12) method=ML;
FORECAST LEAD=5 OUT=out4;
RUN;

PROC ARIMA;                                  /* Model modified(4) */
IDENTIFY VAR=lnx(12) NLAG=36;
ESTIMATE P=(1,3) Q=(12) method=ML;
FORECAST LEAD=5 OUT=out41;
RUN;

PROC ARIMA;                                  /* Model (5) */
IDENTIFY VAR=lnx(12) NLAG=36;
ESTIMATE P=(1,2,3) Q=(1)(12) method=ML;
FORECAST LEAD=5 OUT=out5;
RUN;

PROC ARIMA;                                  /* Model (6) */
IDENTIFY VAR=lnx(1,12) NLAG=36;
ESTIMATE Q=(1)(12) method=ML;
FORECAST LEAD=5 OUT=out6;
RUN;

PROC PRINT DATA=out6; 
RUN;

DATA totalhol;
MERGE hotel out6;
RUN; 

PROC GPLOT DATA=totalhol;
PLOT lnx*t=3 forecast*t=3 /* L95*t=3 U95*t=3 */ /OVERLAY grid frame ;
RUN;

DATA predict;
INPUT t PRED LL UL @@;
PREDe=exp(PRED);
LLe=EXP(LL);
ULe=EXP(LL);
LINES;
169   6.70763   6.66705    6.74821
170   6.63308   6.59250    6.67367
171   6.65006   6.60948    6.69064
172   6.76649   6.72591    6.80707
173   6.75017   6.70958    6.79075
; 

DATA PRE;
SET hotel predict;
RUN;

PROC GPLOT DATA=PRE;
PLOT x*t=3 PREDe*t=2 LLe*t=3 ULe*t=3/OVERLAY grid frame;
RUN;





