DATA DATA1;
INFILE 'G:\BOX-ANN\passenger3.dat';        
INPUT t1 d1 $ x1 t2 d2 $ x12 t3 d3 $ x13 @@;
t=_N_;
IF t>132 THEN DELETE;

x1=log(x1); x12=log(x12); x13=log(x13);  /* CONSTANT VARIANCE */
 
x1 =(x1-4.6443)/(6.3261-4.6443);         /* ON [0,1] */
x12=(x12-4.7361)/(6.4329-4.7361);
x13=(x13-4.7361)/(6.4329-4.7361);

y=x13;                /* target value */

eta=7.01;             /* eta=17; */ 
k=1;
/* numbers of input values 144=132+12 */
/* UNIFORM RANDOM NUMBERS for weights and biases 115 */
IF UNIFORM(1+k)<=0.5 THEN w1_11=-UNIFORM(1+k)/10; ELSE w1_11=UNIFORM(1+k)/10;
IF UNIFORM(2+k)<=0.5 THEN w1_21=-UNIFORM(2+k)/10; ELSE w1_21=UNIFORM(2+k)/10;
IF UNIFORM(3+k)<=0.5 THEN w1_12=-UNIFORM(3+k)/10; ELSE w1_12=UNIFORM(3+k)/10;
IF UNIFORM(4+k)<=0.5 THEN w1_22=-UNIFORM(4+k)/10; ELSE w1_22=UNIFORM(4+k)/10;
    /* I: first linear transformation */
z1=w1_11*x1+w1_21*x12;    
z2=w1_12*x1+w1_22*x12;    
    /* two random biases */
IF UNIFORM(5+k)<=0.5 THEN b1=-UNIFORM(5+k)/10; ELSE b1=UNIFORM(5+k)/10;
IF UNIFORM(6+k)<=0.5 THEN b2=-UNIFORM(6+k)/10; ELSE b2=UNIFORM(6+k)/10;
    /* first 2 activity functions */
s1=1/(1+exp(-(z1+b1))); 
s2=1/(1+exp(-(z2+b2)));

/* I: second linear transformation */
/* UNIFORM RANDOM NUMBERS for 2 weights */

IF UNIFORM(7+k)<=0.5 THEN w2_11=-UNIFORM(7+k)/10; ELSE w2_11=UNIFORM(7+k)/10;
IF UNIFORM(8+k)<=0.5 THEN w2_21=-UNIFORM(8+k)/10; ELSE w2_21=UNIFORM(8+k)/10; 

z3=w2_11*s1+w2_21*s2;

/* second 1 activity function */
IF UNIFORM(9+k)<=0.5 THEN b3=-UNIFORM(9+k)/10; ELSE b3=UNIFORM(9+k)/10;

s3=1/(1+exp(-(z3+b3))); 
y1_hat=s3;
                        
/* 1. BACKPROPAGATION step 1(right hand size) */ /* no more random numbers */
/* for 1st BACKPROPAGATION */
pLpw2_11=-2*(y-y1_hat)*s3*(1-s3)*s1;  
pLpw2_21=-2*(y-y1_hat)*s3*(1-s3)*s2;   

pLpb3=-2*(y-y1_hat)*(s3*(1-s3))*1;      

/* 2. new wights ws_11 etc pp13-14 first line */
w2_11=w2_11-eta*pLpw2_11;    
w2_21=w2_21-eta*pLpw2_21;   

b3=b3-eta*pLpb3;                     
     
/* 2. BACKPROPAGATION step 2(left hand size) */

pLpw1_11=-2*(y-y1_hat)*(w2_11*s3*(1-s3))*(x1*s1*(1-s1));  
pLpw1_21=-2*(y-y1_hat)*(w2_11*s3*(1-s3))*(x12*s1*(1-s1));  
pLpw1_12=-2*(y-y1_hat)*(w2_21*s3*(1-s3))*(x1*s2*(1-s2)); 
pLpw1_22=-2*(y-y1_hat)*(w2_21*s3*(1-s3))*(x12*s2*(1-s2));

pLpb1=-2*(y-y1_hat)*(w2_11*s3*(1-s3))*(1*s1*(1-s1));  
pLpb2=-2*(y-y1_hat)*(w2_21*s3*(1-s3))*(1*s2*(1-s2));

/* SECOND STEP for UPDATED WEIGHTS */

w1_11=w1_11-eta*pLpw1_11;       
w1_21=w1_21-eta*pLpw1_21;     
w1_12=w1_12-eta*pLpw1_12; 
w1_22=w1_22-eta*pLpw1_22;

/* UPDATE biases for BACKPROPAGATION step 2 */
b1=b1-eta*pLpb1;                                     
b2=b2-eta*pLpb2; 

/* new values of z1, z2 */
z1=w1_11*x1+w1_21*x12;   
z2=w1_12*x1+w1_22*x12;

s1=1/(1+exp(-(z1+b1)));   
s2=1/(1+exp(-(z2+b2)));  

z3=w2_11*s1+w2_21*s2;
s3=1/(1+exp(-(z3+b3)));              
y2_hat=s3;               /* The 2nd trained ESTIMATEE */

/* 1. BACKPROPAGATION step 1(right hand size) */

pLpw2_11=-2*(y-y2_hat)*(s3*(1-s3))*s1;   
pLpw2_21=-2*(y-y2_hat)*(s3*(1-s3))*s2;  

pLpb3=-2*(y-y2_hat)*(s3*(1-s3))*1;

/* 2. new wights ws_11 etc pp13-14 first line */

w2_11=w2_11-eta*pLpw2_11;
w2_21=w2_21-eta*pLpw2_21;

b3=b3-eta*pLpb3; 

/* 2. BACKPROPAGATION step 2(left hand size) pp.14-15 */

pLpw1_11=-2*(y-y2_hat)*(w2_11*s3*(1-s3))*(x1*s1*(1-s1)); 
pLpw1_21=-2*(y-y2_hat)*(w2_11*s3*(1-s3))*(x12*s1*(1-s1));
pLpw1_12=-2*(y-y2_hat)*(w2_21*s3*(1-s3))*(x1*s2*(1-s2));
pLpw1_22=-2*(y-y2_hat)*(w2_21*s3*(1-s3))*(x12*s2*(1-s2)); 

pLpb1=-2*(y-y2_hat)*(w2_11*s3*(1-s3))*(1*s1*(1-s1));  
pLpb2=-2*(y-y2_hat)*(w2_21*s3*(1-s3))*(1*s2*(1-s2));

w1_11=w1_11-eta*pLpw1_11;       
w1_21=w1_21-eta*pLpw1_21;     
w1_12=w1_12-eta*pLpw1_12;
w1_22=w1_22-eta*pLpw1_22;

b1=b1-eta*pLpb1; 
b2=b2-eta*pLpb2; 

/* new values of z1, z2 */
z1=w1_11*x1+w1_21*x12; 
z2=w1_12*x1+w1_22*x12;

/* UPDATE biases for BACKPROPAGATION step 2 */
s1=1/(1+exp(-(z1+b1)));                           
s2=1/(1+exp(-(z2+b2)));

z3=w2_11*s1+w2_21*s2;   
s3=1/(1+exp(-(z3+b3)));                              
           
y3_hat=s3;                  
                  
/* 2. BACKPROPAGATION step 2(left hand size) pp.14-15 */

pLpw1_11=-2*(y-y3_hat)*(w2_11*s3*(1-s3))*(x1*s1*(1-s1)); 
pLpw1_21=-2*(y-y3_hat)*(w2_11*s3*(1-s3))*(x12*s1*(1-s1));
pLpw1_12=-2*(y-y3_hat)*(w2_21*s3*(1-s3))*(x1*s2*(1-s2));
pLpw1_22=-2*(y-y3_hat)*(w2_21*s3*(1-s3))*(x12*s2*(1-s2)); 

pLpb1=-2*(y-y3_hat)*(w2_11*s3*(1-s3))*(1*s1*(1-s1));  
pLpb2=-2*(y-y3_hat)*(w2_21*s3*(1-s3))*(1*s2*(1-s2));

w1_11=w1_11-eta*pLpw1_11;       
w1_21=w1_21-eta*pLpw1_21;     
w1_12=w1_12-eta*pLpw1_12;
w1_22=w1_22-eta*pLpw1_22;

b1=b1-eta*pLpb1; 
b2=b2-eta*pLpb2; 

/* new values of z1, z2 */
z1=w1_11*x1+w1_21*x12; 
z2=w1_12*x1+w1_22*x12;

/* UPDATE biases for BACKPROPAGATION step 2 */
s1=1/(1+exp(-(z1+b1)));                           
s2=1/(1+exp(-(z2+b2)));

z3=w2_11*s1+w2_21*s2;   
s3=1/(1+exp(-(z3+b3)));                              
           
y4_hat=s3;                  
        
PROC PRINT; VAR t y y1_hat y2_hat y3_hat y4_hat; 
RUN; 

PROC MEANS; VAR y y1_hat y2_hat y3_hat y4_hat;
RUN; 

DATA NEW1;
SET DATA1;

MSE1=(y-y1_hat)**2;                     
MSE2=(y-y2_hat)**2; 
MSE3=(y-y3_hat)**2;
MSE4=(y-y4_hat)**2;  

MAE1=ABS(y-y1_hat);
MAE2=ABS(y-y2_hat);
MAE3=ABS(y-y3_hat);
MAE4=ABS(y-y4_hat);

y4=lag4(y);

RMSE1=SQRT(MSE1);
RMSE2=SQRT(MSE2);
RMSE3=SQRT(MSE3);
RMSE4=SQRT(MSE4);

y=y*(6.4329-4.7361)+4.7361;
y1_hat=y1_hat*(6.4329-4.7361)+4.7361;
y2_hat=y2_hat*(6.4329-4.7361)+4.7361;
y3_hat=y3_hat*(6.4329-4.7361)+4.7361;
y4_hat=y4_hat*(6.4329-4.7361)+4.7361;

oy=exp(y); 
oy1_hat=exp(y1_hat);
oy2_hat=exp(y2_hat);
oy3_hat=exp(y3_hat);
oy4_hat=exp(y4_hat);

diff1=y1_hat-y;
diff2=y2_hat-y;
diff4=y4_hat-y;
diff22=oy2_hat-oy;
diff44=oy4_hat-oy;

PROC PRINT; VAR Y OY;
RUN;
PROC MEANS DATA=NEW1; VAR MSE1 MSE2 MSE3 MSE4;
RUN;

PROC MEANS DATA=NEW1; VAR MAE1 MAE2 MAE3 MAE4;
RUN; 
 
DATA NEW2;
SET DATA1 NEW1;

MASE_dena=0.000214245;                 /* by hand */

/* IF MASE_dena=0 THEN MASE_dena=0.00001; */

MASE1=MAE1/MASE_dena;    
MASE2=MAE2/MASE_dena;     
MASE3=MAE3/MASE_dena; 
MASE4=MAE4/MASE_dena; 
 
PROC MEANS; VAR MASE1 MASE2 MASE3 MASE4;
RUN;

SYMBOL1 v=dot cv=black l=1 i=line color=red;
SYMBOL2 v=circle cv=black i=line ci=black; 
SYMBOL3 v=star cv=black i=line ci=black; 
SYMBOL4 v=point cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=line ci=black; 
SYMBOL6 v=none cv=black i=spline ci=black;

PROC GPLOT DATA=DATA1;   
PLOT y*t=1/OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=132 VAXIS=0.2 TO 0.8 BY 0.1 HAXIS=0 TO 140 BY 10; */
RUN;

PROC GPLOT DATA=DATA1;   
PLOT y*t=1 y1_hat*t=3 /OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=132 VAXIS=0.2 TO 0.8 BY 0.1 HAXIS=0 TO 140 BY 10; */
RUN;

PROC GPLOT DATA=DATA1;   
PLOT y*t=1 y2_hat*t=3 /OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=132 VAXIS=0.2 TO 0.8 BY 0.1 HAXIS=0 TO 140 BY 10; */
RUN;

PROC GPLOT DATA=DATA1;   
PLOT y*t=1 y3_hat*t=3 /OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=132 VAXIS=0.2 TO 0.8 BY 0.1 HAXIS=0 TO 140 BY 10; */
RUN;

PROC GPLOT DATA=DATA1;   
PLOT y*t=1 y4_hat*t=3 /OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=132 
VAXIS=0.2 TO 0.8 BY 0.1 HAXIS=0 TO 140 BY 10; */
RUN;

PROC GPLOT DATA=DATA1;   
PLOT y*t=1 y1_hat*t=2 y2_hat*t=3 y3_hat*t=4 y4_hat*t=5 /OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=132 VAXIS=0.2 TO 0.8 BY 0.1 HAXIS=0 TO 140 BY 10; */
RUN;

PROC GPLOT DATA=NEW2;   
PLOT oy*t=1 oy2_hat*t=2 /OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=132 
VAXIS=0.2 TO 0.8 BY 0.1 HAXIS=0 TO 140 BY 10; */
RUN;

PROC GPLOT DATA=NEW2;   
PLOT oy*t=1 oy3_hat*t=2 /OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=132 VAXIS=0.2 TO 0.8 BY 0.1 HAXIS=0 TO 140 BY 10; */
RUN;

PROC GPLOT DATA=NEW2;   
PLOT oy*t=1 oy4_hat*t=2 /OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=132 VAXIS=0.2 TO 0.8 BY 0.1 HAXIS=0 TO 140 BY 10; */
RUN;

PROC GPLOT DATA=NEW2;    
PLOT oy*t=1 oy1_hat*t=2 oy2_hat*t=3 oy3_hat*t=4 oy4_hat*t=5 /OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=132 VAXIS=0.2 TO 0.8 BY 0.1 HAXIS=0 TO 140 BY 10; */
RUN;

PROC GPLOT DATA=NEW1;   
PLOT oy*t=1/OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=132 VAXIS=0.2 TO 0.8 BY 0.1 HAXIS=0 TO 140 BY 10; */
RUN;
